#include "coda.h"

// coda di puntatori a lista di interi

void create_queue(coda_Ptr *C)
{
	(*C)=malloc(sizeof(coda));
	(*C)->inizio=NULL;
	(*C)->fine=NULL;
	(*C)->n_elem=0;
}

coda_Ptr enqueue(coda_Ptr C, int n)
{
list_Ptr new=NULL;

	new=malloc(sizeof(list));
	new->val=n;
	new->next=NULL;
	
	if(C->n_elem!=0)
	{
		C->fine->next=new;
		C->fine=new;
		C->n_elem=C->n_elem+1;
		return C;
	}

	else
	{
		C->inizio=new;
		C->fine=new;
		C->n_elem=C->n_elem+1;
		return C;
	}

}

int dequeue(coda_Ptr *C)
{
int n;
list_Ptr temp;

	if((*C)->n_elem==0)
		return 0;

	temp=(*C)->inizio;
	(*C)->n_elem=(*C)->n_elem-1;

	if((*C)->n_elem==0)
	{
		(*C)->inizio=(*C)->fine=NULL;
		n=temp->val;
		free(temp);
		return n;
	}

	else
	{
		(*C)->inizio=(*C)->inizio->next;
		n=temp->val;
		free(temp);
		return n;
	}
		
}

// coda di puntatori a lista di puntatori void

void create_queueVoid(codaVoid_Ptr *C)
{
	(*C)=malloc(sizeof(coda));
	(*C)->inizio=NULL;
	(*C)->fine=NULL;
	(*C)->n_elem=0;
}


codaVoid_Ptr enqueueVoid(codaVoid_Ptr C, void *n)
{
listVoid_Ptr new=NULL;

	if(n)
	{
		new=malloc(sizeof(listVoid));
		new->item=n;
		new->next=NULL;
	
		if(C->n_elem!=0)
		{
			C->fine->next=new;
			C->fine=new;
			C->n_elem=C->n_elem+1;
			return C;
		}

		else
		{
			C->inizio=new;
			C->fine=new;
			C->n_elem=C->n_elem+1;
			return C;
		}
	}

	else
		return C;

}

void* dequeueVoid(codaVoid_Ptr *C)
{
void* n;
listVoid_Ptr temp;

	if((*C)->n_elem==0)
		return NULL;

	temp=(*C)->inizio;
	(*C)->n_elem=(*C)->n_elem-1;

	if((*C)->n_elem==0)
	{
		(*C)->inizio=(*C)->fine=NULL;
		n=temp->item;
		free(temp);
		return n;
	}

	else
	{
		(*C)->inizio=(*C)->inizio->next;
		n=temp->item;
		free(temp);
		return n;
	}
		
}

