#ifndef CODA_H
#define CODA_H

#include "lista.h"
#include <stdlib.h>
#include "tree.h"

// coda di puntatori a lista di interi

typedef struct CODA {
	int n_elem;
	list_Ptr inizio;
	list_Ptr fine;
} coda;
typedef coda *coda_Ptr;

void create_queue(coda_Ptr *C);
coda_Ptr enqueue(coda_Ptr C, int n);
int dequeue(coda_Ptr *C);
 

// coda di puntatori a lista di void

typedef struct CODAVOID {
	int n_elem;
	listVoid_Ptr inizio;
	listVoid_Ptr fine;
} codaVoid;
typedef codaVoid *codaVoid_Ptr;

void create_queueVoid(codaVoid_Ptr *C);
codaVoid_Ptr enqueueVoid(codaVoid_Ptr C, void *n);
void* dequeueVoid(codaVoid_Ptr *C);

#endif

