#ifndef PILA_H
#define PILA_H

#include <stdlib.h>
#include "lista.h"

// stack per le liste
typedef struct STACK{
	list_Ptr item;
	struct STACK *down;
} stack;

typedef stack* stack_Ptr;


// stack per gli interi (ma i void a quando?) :P
typedef struct STACKINT {
	int item;
	struct STACKINT *down;
} stackInt;

typedef stackInt* stack_PtrInt;

// ricordarsi di inizializzare la pila a NULL prima di usarla, altrimenti segmenta
stack_Ptr push(stack_Ptr S, list_Ptr L);
list_Ptr pop(stack_Ptr *S);

// push e pop ma con interi non list_Ptr
stack_PtrInt pushInt(stack_PtrInt S, int n);
int popInt(stack_PtrInt *S);

#endif
