#include <stdio.h>
#include <stdlib.h>
#include "lib/coda.h"
#include "lib/lista.h"
#include "lib/pila.h"
#include "lib/grafi.h"

int main(void)
{
int k,n;
list_Ptr *L;

	printf("di quanti elementi? : ");
	scanf("%d",&n);
	L=costruisci(L,n);

	printf("\n\nil grafo inserito e' :\n\n");
	printList(L,n);

	printf("\n\nda quale elemento si vuole partire? :");
	scanf("%d",&k);

	printf("\n\nil numero di componenti connesse e' %d\n",compConn(L,k,n));
	return 0;
}

/* esempio di esecuzione....  
 
 il grafo inserito e' :

 1|->2->3->NULL
 2|->3->1->NULL
 3|->2->1->4->NULL
 4|->3->5->6->NULL
 5|->4->6->NULL
 6|->5->4->7->10->NULL
 7|->6->10->8->NULL
 8|->7->9->NULL
 9|->8->10->NULL
10|->6->7->9->NULL


ora eseguo la visita in profondita' del grafo..
da quale nodo si vuole iniziare? : 1
sto visitando 1
sto visitando 2
sto visitando 3
sto visitando 4
sto visitando 6
sto visitando 5
sto visitando 10
sto visitando 9
sto visitando 8
sto visitando 7

*/

