#include <stdio.h>
#include <stdlib.h>

typedef struct NODE{

	int val;
	struct NODE *next;
} node;

typedef node* nodePtr;

nodePtr addTail(nodePtr L, int elem)
{
nodePtr tmp=L;

	if(!L)
	{
		L=malloc(sizeof(node));
		L->next=NULL;
		L->val=elem;
		return L;
	}

	else
	{
		while(L->next)
			L=L->next;

		L->next=malloc(sizeof(node));
		L->next->val=elem;
		L->next->next=NULL;
		return tmp;
	}
}

void prova_distruzione(nodePtr *L)
{
	while(*L)
		*L=(*L)->next;
}

void stampa(nodePtr L)
{
	while(L)
	{
		printf("%d ",L->val);
		L=L->next;
	}

	printf("\n");
}

nodePtr *ordina_m(nodePtr *lista, int n)
{
int i;
nodePtr tmp,*lista_1=calloc(n,sizeof(nodePtr));

	for(i=0;i<n;i++)
	{
		tmp=lista[i];
		while(tmp)
		{
			lista_1[tmp->val-1]=addTail(lista_1[tmp->val-1],i+1);
			tmp=tmp->next;
		}	
	}

	return lista_1;
}

int main(void)
{
int n,i,k;
nodePtr *lista=NULL,*lista_1=NULL;	

	printf("inserire il numero di vertici : ");
	scanf("%d",&n);

	lista=calloc(n,sizeof(nodePtr));

	for(i=0;i<n;i++)
	{
		printf("sono al nodo %d\n",i+1);
		printf("(0 per skippare numero per aggiungere) : ");
		scanf("%d",&k);

		while(k)
		{
			printf("(0 per skippare numero per aggiungere) : ");
			lista[i]=addTail(lista[i],k);
			scanf("%d",&k);
		}
	}
			
	printf("\n");
	
	for(i=0;i<n;i++)
	{
		printf("%d--->",i+1);
		stampa(lista[i]);
	}

	
	lista_1=ordina_m(lista,n);
	
	for(i=0;i<n;i++)
	{
		printf("%d--->",i+1);
		stampa(lista_1[i]);
	}


	printf("\n");
	
	for(i=0;i<n;i++)
	{
		printf("%d--->",i+1);
		stampa(lista[i]);
	}

	
	lista_1=ordina_m(lista,n);
	
	for(i=0;i<n;i++)
	{
		printf("%d--->",i+1);
		stampa(lista_1[i]);
	}


	
	return 0;
}
